(* print "\n** R1: consists of only constants. **\n";
val rs = Trs.rdRules "[a -> b, a -> c, c -> c, d -> c, d -> e]";
UN.checkUN_print rs; 

print "\n** R2: there exists a witness that is equivalent to a constant (simple rules, flat) **\n";
val rs = Trs.rdRules "[f(?x,a) -> a, a -> b]";
UN.checkUN_print rs;

print "\n** R3: there exists a witness that is not equivalent to any constant (simple rules, flat) **\n";
val rs = Trs.rdRules "[g(?y) -> f(?x,?y)]";
UN.checkUN_print rs; 

print "\n** R4: UN (simple rules, flat)**\n";
val rs = Trs.rdRules "[a -> b, b -> a, f(?x,?y) -> a]";
UN.checkUN_print rs; 

print "\n** R5: inconsistent **\n";
val rs = Trs.rdRules "[a -> b, b -> a, f(?x,?y) -> a, f(?x,?y) -> ?z]";
UN.checkUN_print rs; 

print "\n** R6: UN (simple rules, shallow, height=2) **\n";
val rs = Trs.rdRules "[f(g(a),?y) -> ?y]";
UN.checkUN_print rs; 

print "\n** R7: UN (simple rules, shallow, height=3) **\n";
val rs = Trs.rdRules "[f(g(h(a)),?y) -> ?y]";
UN.checkUN_print rs;

print "\n** R8: there exists a witness that is equivalent to a constant (complex rules, shallow) **\n";
val rs = Trs.rdRules "[f(?x,?y) -> a, f(k(l(a1,a2),a1,a3),?y)-> a, f(?x,u) -> a, a -> g(b1,u,?x), b1 -> b, b -> h(?x,d), h(?y,d) -> i(c), u -> j(v)]";
UN.checkUN_print rs; 

print "\n** R9: there exists a witness that is not equivalent to any constants (complex rules, shallow) **\n";
val rs = Trs.rdRules "[f(?x,?y) -> a, f(k(l(a1,a2),a1,a3),?y)-> a, f(?x,u) -> a, a -> g(b1,u), b1 -> b, b -> h(?x,d), h(?y,d) -> i(c), u -> j(v), m(?x,?x) -> n(?y)]";
UN.checkUN_print rs;

print "\n** R10: UN (complex rules, shallow) **\n";
val rs = Trs.rdRules "[f(?x,?y) -> a, f(k(l(a1,a2),a1,a3),?y)-> a, f(?x,u) -> a, a -> g(b1,u), b1 -> b, b -> h(?x,d), h(?y,d) -> i(c), u -> j(v)]";
UN.checkUN_print rs;
*)

print "\n** R11: non-linear. not UN. **\n";
val rs = Trs.rdRules "[f(?x) -> g(a, ?x), f(?x) -> g(?x, a), g(?x, ?x) -> f(?x)]";
UN.checkUN_print rs; 

print "\n** R12: non-linear. UN. **\n";
val rs = Trs.rdRules "[f(?x, ?x) -> g(?x) , f(a, b) -> g(a)]";
UN.checkUN_print rs;
